"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from redrover_api.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from redrover_api.exceptions import ApiAttributeError


def lazy_import():
    from redrover_api.model.accounting_code_allocation_response import AccountingCodeAllocationResponse
    from redrover_api.model.approval_status_enum import ApprovalStatusEnum
    from redrover_api.model.int32_id_name_class import Int32IdNameClass
    from redrover_api.model.pay_code_response import PayCodeResponse
    from redrover_api.model.simple_absence_detail import SimpleAbsenceDetail
    from redrover_api.model.simple_person import SimplePerson
    from redrover_api.model.simple_position import SimplePosition
    globals()['AccountingCodeAllocationResponse'] = AccountingCodeAllocationResponse
    globals()['ApprovalStatusEnum'] = ApprovalStatusEnum
    globals()['Int32IdNameClass'] = Int32IdNameClass
    globals()['PayCodeResponse'] = PayCodeResponse
    globals()['SimpleAbsenceDetail'] = SimpleAbsenceDetail
    globals()['SimplePerson'] = SimplePerson
    globals()['SimplePosition'] = SimplePosition


class VacancyDetailSearchResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'notes_to_admin': (str, none_type,),  # noqa: E501
            'absence_detail': (SimpleAbsenceDetail,),  # noqa: E501
            'vacancy_id': (int,),  # noqa: E501
            'is_deleted': (bool,),  # noqa: E501
            'position': (SimplePosition,),  # noqa: E501
            'created_utc': (datetime,),  # noqa: E501
            'id': (int,),  # noqa: E501
            'assignment_id': (int, none_type,),  # noqa: E501
            'substitute': (SimplePerson,),  # noqa: E501
            'external_assignment_number': (str, none_type,),  # noqa: E501
            'assignment_is_long_term': (bool, none_type,),  # noqa: E501
            'assignment_notes': (str, none_type,),  # noqa: E501
            'location': (Int32IdNameClass,),  # noqa: E501
            'start': (datetime,),  # noqa: E501
            'end': (datetime,),  # noqa: E501
            'actual_duration_minutes': (int,),  # noqa: E501
            'accounting_codes': ([AccountingCodeAllocationResponse], none_type,),  # noqa: E501
            'pay_duration': (float,),  # noqa: E501
            'pay_unit': (str, none_type,),  # noqa: E501
            'pay_code': (PayCodeResponse,),  # noqa: E501
            'vacancy_reason': (Int32IdNameClass,),  # noqa: E501
            'verified': (bool,),  # noqa: E501
            'verified_at_utc': (datetime, none_type,),  # noqa: E501
            'verify_comment': (str, none_type,),  # noqa: E501
            'verified_by': (Int32IdNameClass,),  # noqa: E501
            'approval_status': (str, none_type,),  # noqa: E501
            'approval_status_id': (ApprovalStatusEnum,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'notes_to_admin': 'notesToAdmin',  # noqa: E501
        'absence_detail': 'absenceDetail',  # noqa: E501
        'vacancy_id': 'vacancyId',  # noqa: E501
        'is_deleted': 'isDeleted',  # noqa: E501
        'position': 'position',  # noqa: E501
        'created_utc': 'createdUtc',  # noqa: E501
        'id': 'id',  # noqa: E501
        'assignment_id': 'assignmentId',  # noqa: E501
        'substitute': 'substitute',  # noqa: E501
        'external_assignment_number': 'externalAssignmentNumber',  # noqa: E501
        'assignment_is_long_term': 'assignmentIsLongTerm',  # noqa: E501
        'assignment_notes': 'assignmentNotes',  # noqa: E501
        'location': 'location',  # noqa: E501
        'start': 'start',  # noqa: E501
        'end': 'end',  # noqa: E501
        'actual_duration_minutes': 'actualDurationMinutes',  # noqa: E501
        'accounting_codes': 'accountingCodes',  # noqa: E501
        'pay_duration': 'payDuration',  # noqa: E501
        'pay_unit': 'payUnit',  # noqa: E501
        'pay_code': 'payCode',  # noqa: E501
        'vacancy_reason': 'vacancyReason',  # noqa: E501
        'verified': 'verified',  # noqa: E501
        'verified_at_utc': 'verifiedAtUtc',  # noqa: E501
        'verify_comment': 'verifyComment',  # noqa: E501
        'verified_by': 'verifiedBy',  # noqa: E501
        'approval_status': 'approvalStatus',  # noqa: E501
        'approval_status_id': 'approvalStatusId',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """VacancyDetailSearchResponse - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            notes_to_admin (str, none_type): Any notes to the admin. [optional]  # noqa: E501
            absence_detail (SimpleAbsenceDetail): [optional]  # noqa: E501
            vacancy_id (int): Id of the Vacancy. [optional]  # noqa: E501
            is_deleted (bool): If the vacancy was deleted. [optional]  # noqa: E501
            position (SimplePosition): [optional]  # noqa: E501
            created_utc (datetime): When the Vacancy Detail was created. [optional]  # noqa: E501
            id (int): Id of the Vacancy Detail. [optional]  # noqa: E501
            assignment_id (int, none_type): Id of the Assignment. [optional]  # noqa: E501
            substitute (SimplePerson): [optional]  # noqa: E501
            external_assignment_number (str, none_type): Assignment number to match another system. [optional]  # noqa: E501
            assignment_is_long_term (bool, none_type): Is this assignment considered long term?. [optional]  # noqa: E501
            assignment_notes (str, none_type): Notes about this assignment. [optional]  # noqa: E501
            location (Int32IdNameClass): [optional]  # noqa: E501
            start (datetime): When the Vacancy starts. [optional]  # noqa: E501
            end (datetime): When the Vacancy ends. [optional]  # noqa: E501
            actual_duration_minutes (int): How long the Vacancy Detail is scheduled (minutes). [optional]  # noqa: E501
            accounting_codes ([AccountingCodeAllocationResponse], none_type): The Accounting codes associated with the Vacancy. [optional]  # noqa: E501
            pay_duration (float): The Calculated Effective Duration (Days or Minutes). [optional]  # noqa: E501
            pay_unit (str, none_type): The pay unit. ('DAYS', 'MINUTES'). [optional]  # noqa: E501
            pay_code (PayCodeResponse): [optional]  # noqa: E501
            vacancy_reason (Int32IdNameClass): [optional]  # noqa: E501
            verified (bool): If the Vacancy has been verified. [optional]  # noqa: E501
            verified_at_utc (datetime, none_type): When the Vacancy was verified. [optional]  # noqa: E501
            verify_comment (str, none_type): Comment made when the Vacancy was verified. [optional]  # noqa: E501
            verified_by (Int32IdNameClass): [optional]  # noqa: E501
            approval_status (str, none_type): The current approval status of the vacancy. [optional]  # noqa: E501
            approval_status_id (ApprovalStatusEnum): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """VacancyDetailSearchResponse - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            notes_to_admin (str, none_type): Any notes to the admin. [optional]  # noqa: E501
            absence_detail (SimpleAbsenceDetail): [optional]  # noqa: E501
            vacancy_id (int): Id of the Vacancy. [optional]  # noqa: E501
            is_deleted (bool): If the vacancy was deleted. [optional]  # noqa: E501
            position (SimplePosition): [optional]  # noqa: E501
            created_utc (datetime): When the Vacancy Detail was created. [optional]  # noqa: E501
            id (int): Id of the Vacancy Detail. [optional]  # noqa: E501
            assignment_id (int, none_type): Id of the Assignment. [optional]  # noqa: E501
            substitute (SimplePerson): [optional]  # noqa: E501
            external_assignment_number (str, none_type): Assignment number to match another system. [optional]  # noqa: E501
            assignment_is_long_term (bool, none_type): Is this assignment considered long term?. [optional]  # noqa: E501
            assignment_notes (str, none_type): Notes about this assignment. [optional]  # noqa: E501
            location (Int32IdNameClass): [optional]  # noqa: E501
            start (datetime): When the Vacancy starts. [optional]  # noqa: E501
            end (datetime): When the Vacancy ends. [optional]  # noqa: E501
            actual_duration_minutes (int): How long the Vacancy Detail is scheduled (minutes). [optional]  # noqa: E501
            accounting_codes ([AccountingCodeAllocationResponse], none_type): The Accounting codes associated with the Vacancy. [optional]  # noqa: E501
            pay_duration (float): The Calculated Effective Duration (Days or Minutes). [optional]  # noqa: E501
            pay_unit (str, none_type): The pay unit. ('DAYS', 'MINUTES'). [optional]  # noqa: E501
            pay_code (PayCodeResponse): [optional]  # noqa: E501
            vacancy_reason (Int32IdNameClass): [optional]  # noqa: E501
            verified (bool): If the Vacancy has been verified. [optional]  # noqa: E501
            verified_at_utc (datetime, none_type): When the Vacancy was verified. [optional]  # noqa: E501
            verify_comment (str, none_type): Comment made when the Vacancy was verified. [optional]  # noqa: E501
            verified_by (Int32IdNameClass): [optional]  # noqa: E501
            approval_status (str, none_type): The current approval status of the vacancy. [optional]  # noqa: E501
            approval_status_id (ApprovalStatusEnum): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
